pice <- read.table("C:/Users/Administrator/ZRA/Anwendungen/pice/PersDisIncConsExp.txt", header= T)
inc <- pice[,2]
ts.plot(inc)
i <- diff(inc,1)
i <- i - mean(i)

par(mfrow = c(1,2))
acf(i, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(i, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")
#Entscheidung: AR[1], AR[10]

##Anpassung eines AR[1]-Modells an die Reihe i
out <- arima(i, order = c(1,0,0), include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")
################################################################################

##Anpassung eines AR[10]-Modells an die Reihe i
out <- arima(i, order = c(10,0,0), include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef
tstat <- round(out$coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[10]-Modells mit 9 Parametern an die Reihe i
fix = c( NA, NA, NA, NA, NA, NA, NA, NA, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef[c(1:8,10)]
tstat <- round(coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[10]-Modells mit 8 Parametern an die Reihe i
fix = c( NA, NA, NA, NA, NA, 0, NA, NA, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef[c(1:5,7,8,10)]
tstat <- round(coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[10]-Modells mit 7 Parametern an die Reihe i
fix = c( NA, NA, NA, NA, 0, 0, NA, NA, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef[c(1:4,7,8,10)]
tstat <- round(coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[10]-Modells mit 6 Parametern an die Reihe i
fix = c( NA, NA, NA, NA, 0, 0, NA, 0, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef[c(1:4,7,10)]
tstat <- round(coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[10]-Modells mit 5 Parametern an die Reihe i
fix = c( NA, NA, NA, NA, 0, 0, 0, 0, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef[c(1:4,10)]
tstat <- round(coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[10]-Modells mit 4 Parametern an die Reihe i
fix = c( NA, NA, 0, NA, 0, 0, 0, 0, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef[c(1,2,4,10)]
tstat <- round(coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)

#Box-Pierce-Ljung Test
res <- out$resid
n.par <- 4 # Anzahl geschtzter Parameter
Box <- matrix(0,4,3)
m <- c(12,14,16,18)
m <- m[m>n.par]
for(i in c(1:length(m))){
bt <- Box.test(res, lag = m[i], type = "Ljung-Box")
pw <- 1-pchisq(bt$statistic, m[i]-n.par)
Box[i,]<- c(bt$parameter, bt$statistic, pw)}
colnames(Box)<- c("Lags", "Statistik", "P-Wert")
Box

#Informationskriterien
ord <- 4  # Anzahl geschtzter Parameter
N <- length(i) #N = Anzahl der Beobachtungen
rss <- rep(0,2)
aic <- rep(0,2)
aicc <- rep(0,2)
bic <- rep(0,2)   

rss[1] <- sum((res-mean(res))^2)
aic[1] <- log(rss[1]/N) + 2*ord/N
aicc[1] <- log(rss[1]/N) + 2*ord/(N-ord-2)
bic[1] <- log(rss[1]/N) + ord*log(N)/N
################################################################################

#Anpassung eines Subset-AR[10]-Modells mit 3 Parametern an die Reihe i
fix = c( NA, 0, 0, NA, 0, 0, 0, 0, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out
# ACF und PACF der Residuen
par(mfrow = c(1,2))
acf(out$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out$coef[c(1,4,10)]
tstat <- round(coef/diag(out$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)

#Box-Pierce-Ljung Test
res <- out$resid
n.par <- 3 # Anzahl geschtzter Parameter
Box <- matrix(0,4,3)
m <- c(12,14,16,18)
m <- m[m>n.par]
for(i in c(1:length(m))){
bt <- Box.test(res, lag = m[i], type = "Ljung-Box")
pw <- 1-pchisq(bt$statistic, m[i]-n.par)
Box[i,]<- c(bt$parameter, bt$statistic, pw)}
colnames(Box)<- c("Lags", "Statistik", "P-Wert")
Box

#Informationskriterien
ord <- 3  # Anzahl geschtzter Parameter
rss[2] <- sum((res-mean(res))^2)
aic[2] <- log(rss[2]/N) + 2*ord/N
aicc[2] <- log(rss[2]/N) + 2*ord/(N-ord-2)
bic[2] <- log(rss[2]/N) + ord*log(N)/N
#Ich entscheide mich fr das Subset-AR[10]-Modell mit 3 Parametern