pice <- read.table("C:/Users/Administrator/ZRA/Anwendungen/pice/PersDisIncConsExp.txt", header= T)
inc <- pice[,2] #income
con <- pice[,3] #consumption expenditure
ts.plot(inc)
lines(con, col = 'red')

c <- diff(con,1)
c <- c - mean(c)
i <- diff(inc,1)
i <- i - mean(i)

#Anpassung eines Subset-AR[10]-Modells mit 3 Parametern an die Reihe i
fix = c( NA, 0, 0, NA, 0, 0, 0, 0, 0, NA)
out <- arima(i, order = c(10,0,0), fixed =fix, include.mean = F)
out

#I.2 Filtern der Input-Reihe (Prewhitening)
input <- out$resid

#I.3 Filtern der Output-Reihe
fix <- out$coef
out_c <- arima(c, order= c(10,0,0), fixed = fix, include.mean = F)
###Die Residuen entsprechen der gefilterten Output-Reihe
output <- out_c$resid

#I.d Schtzung der Transferfunktion auf der Grundlage der CCF der gefilterten Reihen
par(mfrow = c(1,1))
ccf(input, output, 10) ###Lags -10, -4 und 0
nu <- ccf(input, output, 10)
nu <- c(nu$acf[1], nu$acf[7], nu$acf[11]) * sd(output) / sd(input)

#********************************************************************************
#II. Anpassung eines ARMA-Modells an die Residuenreihe
N <- length(c)
noise <- c[11:N] - i[11:N]*nu[3] - i[7:(N-4)]*nu[2] - i[1:(N-10)]*nu[1]
# ACF und PACF der Reihe noise
par(mfrow = c(1,2))
acf(noise, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(noise, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")
#AR[5]

#Anpassung eines AR[5]-Modells an die Residuenreihe noise
out2 <- arima(noise, order = c(5,0,0), include.mean = F)
out2
# ACF und PACF der neuen Residuen
par(mfrow = c(1,2))
acf(out2$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out2$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out2$coef
tstat <- round(coef/diag(out2$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[5]-Modells mit 4 Parametern an die Residuenreihe noise
fix = c( NA, NA, NA, 0, NA)
out2 <- arima(noise, order = c(5,0,0), fixed =fix, include.mean = F)
out2
# ACF und PACF der neuen Residuen
par(mfrow = c(1,2))
acf(out2$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out2$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out2$coef[c(1:3,5)]
tstat <- round(coef/diag(out2$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[5]-Modells mit 3 Parametern an die Residuenreihe noise
fix = c( NA, 0, NA, 0, NA)
out2 <- arima(noise, order = c(5,0,0), fixed =fix, include.mean = F)
out2
# ACF und PACF der neuen Residuen
par(mfrow = c(1,2))
acf(out2$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out2$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out2$coef[c(1,3,5)]
tstat <- round(coef/diag(out2$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[5]-Modells mit 2 Parametern an die Residuenreihe noise
fix = c( 0, 0, NA, 0, NA)
out2 <- arima(noise, order = c(5,0,0), fixed =fix, include.mean = F)
out2
# ACF und PACF der neuen Residuen
par(mfrow = c(1,2))
acf(out2$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out2$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out2$coef[c(3,5)]
tstat <- round(coef/diag(out2$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)
################################################################################

#Anpassung eines Subset-AR[5]-Modells mit 1 Parameter an die Residuenreihe noise
fix = c( 0, 0, 0, 0, NA)
out2 <- arima(noise, order = c(5,0,0), fixed =fix, include.mean = F)
out2
# ACF und PACF der neuen Residuen
par(mfrow = c(1,2))
acf(out2$resid, lag.max = 20, xlab=expression(tau), main = "ACF mit Bartlett-Grenzen", ci.type = "ma")
pacf(out2$resid, lag.max = 20, xlab=expression(tau), main = "PACF mit White-Noise-Grenzen")

#berprfung der Parametersignifikanz
coef <- out2$coef[c(5)]
tstat <- round(coef/diag(out2$var.coef)^.5, 4)
pwert<- round(2*(1-pnorm(abs(tstat))),4)
cbind(coef, tstat, pwert)